#include <stdio.h>

union dtype {
double d;
int l [sizeof(double)/sizeof(int)];
};
typedef union dtype dtype;

union ftype {
float f;
int i[sizeof(float)/sizeof(int)];
};
typedef union ftype ftype;

void printhex(const char * name, const int * word, int len) {
	int i;

	printf("%s = ", name);
	for (i = 0; i < len; ++ i) {
		printf(" %x", word[i]);
	}
	puts("");
}

int main(void) {
	dtype d;
	ftype f;
	ftype g;

	printf("sizeof(double) = %d\n", sizeof(double));
	printf("sizeof(float) = %d\n", sizeof(float));
	printf("sizeof(int) = %d\n", sizeof(int));
	printf("sizeof(long) = %d\n", sizeof(long));
	printf("sizeof(long long) = %d\n", sizeof(long long));

	printf("sizeof(dtype.l) = %d\n", sizeof(d.l));
	printf("sizeof(ftype.i) = %d\n", sizeof(f.i));

	d.d = 1.7976931348623157E308;

	f.f = d.d;
	g.f = (float) d.d;

	printf("d = %g\t f = %g\t g=%g\n", d.d, f.f, g.f);

	printhex("d", d.l, sizeof(d.l)/sizeof(int));
	printhex("f", f.i, sizeof(f.i)/sizeof(int));
	printhex("g", g.i, sizeof(g.i)/sizeof(int));
/*
	printf("d = %Lx\t f = %x\t g=%x\n", d.l, f.i, g.i); 	
*/
	f.f = 3.4028234663852885981e+38f;
	printf("f.f = %g\n", f.f);

	printhex("f.i", f.i, sizeof(f.i)/sizeof(int));

	g.f *= -1.0;
	printf("g.f = %g\n", g.f);

	printhex("g.i", g.i, sizeof(g.i)/sizeof(int));

	return 0;
}
